#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

void millisec_sleep(msec)
long msec;
{
    struct timeval t;
    t.tv_sec = msec / 1000;
    t.tv_usec = (msec % 1000) * 1000;
    select(0, NULL, NULL, NULL, &t);
}

int main(argc, argv)
int argc; char *argv[];
{
    FILE *moviefile;
    char buf[4096];
    int i;
    
    if (argc == 2) {
	moviefile = fopen(argv[1], "r");
	if (moviefile == NULL) {
	    fprintf(stderr, "Error opening file `%s'\n", argv[1]);
	    return 1;
	}
    } else {
	fprintf(stderr, "Usage: %s filename\n", argv[0]);
	return 1;
    }
    
    while (fgets(buf, 4096, moviefile) != NULL) {
	i = strlen(buf);
	if (i > 0 && buf[i-1] == '\n')
	    buf[i-1] = '\0';
	if (!strncmp(buf, "sleep ", 6))
	    millisec_sleep(atoi(buf + 6));
	else if (!strncmp(buf, "line ", 5))
	    printf("%s\n", buf + 5);
	else if (!strncmp(buf, "prompt ", 7))
	    printf("%s", buf + 7);
	else {
	    fprintf(stderr, "Syntax error in line:\n%s\n", buf);
	    return 1;
	}
	fflush(stdout);
    }
    if (feof(moviefile)) {
	printf("\n");
	return 0;
    } else {
	fprintf(stderr, "Error reading file\n");
	return 1;
    }
}

